diff -aur --exclude='*.beam' --exclude=configure --exclude=Makefile otp_src_P9C_2003-07-22/erts/emulator/beam/erl_bif_port.c otp_src_P9C_2003-07-22.fixed/erts/emulator/beam/erl_bif_port.c
--- otp_src_P9C_2003-07-22/erts/emulator/beam/erl_bif_port.c	2003-07-07 14:17:09.000000000 +0200
+++ otp_src_P9C_2003-07-22.fixed/erts/emulator/beam/erl_bif_port.c	2003-07-23 09:55:43.000000000 +0200
@@ -207,19 +207,22 @@
     size_t real_size;
     ErlDrvEntry *drv;
     byte  port_result[128];	/* Buffer for result from port. */
-    byte* port_resp;		/* Pointer to result buffer. */
+    union {
+      char *cp;
+      byte *bp;
+    } port_resp;                /* Pointer to result buffer. */
     int ret;
     Eterm res;
     int result_size;
     Eterm *hp;
     unsigned ret_flags = 0U;
 
-    port_resp = port_result;
+    port_resp.bp = port_result;
     if ((p = id_or_name2port(BIF_ARG_1)) == NULL) {
     error:
-	if (port_resp != port_result && 
+	if (port_resp.bp != port_result && 
 	    !(ret_flags & DRIVER_CALL_KEEP_BUFFER)) {
-	    driver_free(port_resp);
+	    driver_free(port_resp.bp);
 	}
 	BIF_ERROR(BIF_P, BADARG);
     }
@@ -250,7 +253,7 @@
 		    (unsigned) op,
 		    (char *) bytes, 
 		    (int) real_size,
-		    (char **) &port_resp, 
+		    (char **) &port_resp.cp, 
 		    (int) sizeof(port_result),
 		    &ret_flags);
 #ifdef HARDDEBUG
@@ -265,28 +268,28 @@
 	printf("]\r\n");
 	printf("[");
 	for(z = 0; z < ret; ++z) {
-	    printf("%d, ",(int) port_resp[z]);
+	    printf("%d, ",(int) port_resp.bp[z]);
 	}
 	printf("]\r\n");
     }
 #endif
-    if (ret <= 0 || port_resp[0] != VERSION_MAGIC) { 
+    if (ret <= 0 || port_resp.bp[0] != VERSION_MAGIC) { 
 	/* Error or a binary without magic/ with wrong magic */
 	goto error;
     }
-    result_size = decode_size(port_resp, ret);
+    result_size = decode_size(port_resp.bp, ret);
     if (result_size < 0) {
 	goto error;
     }
     hp = HAlloc(BIF_P, result_size);
-    endp = port_resp;
+    endp = port_resp.bp;
     if ((res = erts_from_external_format(NULL, &hp, &endp, &MSO(BIF_P)))
 	== THE_NON_VALUE) {
 	goto error;
     }
     HRelease(BIF_P, hp);
-    if (port_resp != port_result && !(ret_flags & DRIVER_CALL_KEEP_BUFFER)) {
-	driver_free(port_resp);
+    if (port_resp.bp != port_result && !(ret_flags & DRIVER_CALL_KEEP_BUFFER)) {
+	driver_free(port_resp.bp);
     }
     return res;
 }
diff -aur --exclude='*.beam' --exclude=configure --exclude=Makefile otp_src_P9C_2003-07-22/erts/emulator/sys/unix/sys.c otp_src_P9C_2003-07-22.fixed/erts/emulator/sys/unix/sys.c
--- otp_src_P9C_2003-07-22/erts/emulator/sys/unix/sys.c	2003-07-07 16:37:17.000000000 +0200
+++ otp_src_P9C_2003-07-22.fixed/erts/emulator/sys/unix/sys.c	2003-07-23 09:53:07.000000000 +0200
@@ -203,13 +203,13 @@
 static struct k_poll   dev_poll;      /* control block for /dev/kpoll */
 static int max_poll_idx;              /* highest non /dev/kpoll fd */
 
-static void kpoll_enable();
+static void kpoll_enable(void);
 #else
 static struct dvpoll   dev_poll;      /* control block for /dev/poll */
 #endif /* !HAVE_LINUX_KPOLL_H */
 static struct pollfd*  dev_poll_rfds = NULL; /* Allocated at startup */
 
-static void devpoll_init();
+static void devpoll_init(void);
 static void devpoll_update_pix(int pix);
 #ifdef HAVE_SYS_DEVPOLL_H
 static void devpoll_clear_pix(int pix);
@@ -223,8 +223,8 @@
 static struct kevent    *kqueue_res;
 static int              max_poll_idx;   /* highest non kqueue fd */
 
-static void kqueue_init();
-static void kqueue_enable();
+static void kqueue_init(void);
+static void kqueue_enable(void);
 static void kqueue_update_pix(int pix, int old_events);
 
 #define ERL_POLL_READY_ENTRIES  2
@@ -407,6 +407,8 @@
 {
     struct sigaction act, oact;
 
+    memset(&act, (char)0, sizeof(act));
+
     sigemptyset(&act.sa_mask);
     act.sa_flags = 0;
     act.sa_handler = func;
@@ -3285,7 +3287,7 @@
 
 #ifdef USE_KQUEUE
 
-static void kqueue_init()
+static void kqueue_init(void)
 {
     if ( getenv("ERL_NO_KERNEL_POLL") != NULL ) {
         DEBUGF(("Use of kqueue disabled\n"));
@@ -3308,7 +3310,7 @@
     }
 }
 
-static void kqueue_enable()
+static void kqueue_enable(void)
 {
     int pix;
     
@@ -3406,7 +3408,7 @@
 #ifdef USE_DEVPOLL
 
 #if HAVE_LINUX_KPOLL_H
-static void kpoll_enable()
+static void kpoll_enable(void)
 {
     int pix;
     
@@ -3422,7 +3424,7 @@
     poll_fds[pix].revents = 0;
 }
 
-static void kpoll_init()
+static void kpoll_init(void)
 {
     if ( (dev_poll_fd=open("/dev/kpoll",O_RDWR)) < 0 ) {
         /* This will happen if the module is not inserted yet as well... */
@@ -3448,7 +3450,7 @@
 
 #ifdef HAVE_SYS_DEVPOLL_H
 
-static void solaris_devpoll_init()
+static void solaris_devpoll_init(void)
 {
     if ( (dev_poll_fd=open("/dev/poll",O_RDWR)) < 0 ) {
         DEBUGF(("Will use poll()\n"));
@@ -3464,7 +3466,7 @@
 
 #endif
 
-static void devpoll_init() 
+static void devpoll_init(void) 
 {
     if ( getenv("ERL_NO_KERNEL_POLL") != NULL ) {
         DEBUGF(("Use of kernel poll disabled.\n"));
